<?php
/**
* @package asama
* @category include/parts
*/
global $HSTL;
$MD = $HSTL->theMode(); ?>
<header class='page' role='<?php echo "page".$MD; ?>'>
<article class='content hustleFlex' name='Pennant' role='banner'><div class='logo'>
<?php //LOGO SET
$BGIMG = '';
if (has_custom_logo()):
	$BGIMG = 'background-image:url('.wp_get_attachment_url(get_theme_mod('custom_logo'),'full').');';
endif;
if(is_front_page()): ?>
	<span class='mark' style='<?php echo $BGIMG ?>'>
<?php else: ?>
	<a class='mark' href='<?php echo esc_attr(home_url("/")); ?>' style='<?php echo $BGIMG ?>'>
<?php endif; ?>
<span><?php bloginfo('name'); ?></span>
<?php echo (is_front_page())?'</span>':'</a>' ?>
<span class='catch' name='SiteCatch'><?php bloginfo('description'); ?></span></div>
<nav class='menu' role='navigation'>
<?php // PENNANT NAVIGATION
wp_nav_menu(array(
'theme_location' => 'pennant_nav',
'menu_class' => 'hustleFlex',
'container_class' => 'pennantMenuSet',
'items_wrap' => '<ul id="pennantMenu" class="%2$s">%3$s</ul>',
'fallback_cb' => false,
));
?>
</nav>
</article>
<aside class='content' name='WidgetColumn' role='servant'>
<?php // HUSTLE TAG CLOUD
if($HSTL->isHustleTagCloud()): ?>
	<article class='column' name='AsamaTagCloud'>
	<?php if(is_bool($HSTL->hustleTagCloud)):
		if($HSTL->hustleTagCloud):
			echo do_shortcode('[hustleShort file="include/shortcode/TagCloud"]');
		endif;
	else:
		echo do_shortcode($HSTL->hustleTagCloud);
	endif; ?>
	</article>
<?php endif;
// WIDGET COLUMN IN HEADER
if(is_active_sidebar('widget-column-header')):
	dynamic_sidebar('widget-column-header');
endif; ?>
</aside>
</header>